diff --git src/video/cocoa/SDL_cocoamodes.m src/video/cocoa/SDL_cocoamodes.m
index fa5b18458..3a71725f9 100644
--- src/video/cocoa/SDL_cocoamodes.m
+++ src/video/cocoa/SDL_cocoamodes.m
@@ -41,6 +41,65 @@
 #define kDisplayModeNativeFlag 0x02000000
 #endif
 
+/* !!! FIXME: clean out the pre-10.6 code when it makes sense to do so. */
+#ifndef FORCE_OLD_API
+#define FORCE_OLD_API 0
+#endif
+
+/* The old pre-10.6 CGDisplay API (CFDictionary-based display modes) is used
+ * when targeting the 10.5 SDK or older, or when explicitly requested with
+ * -DFORCE_OLD_API=1.  The latter is needed on OS builds - e.g. some of the
+ * PowerPC Mac OS X 10.6.8 images - whose CoreGraphics/OpenGL stack predates
+ * the CGDisplayMode API even though the 10.6 SDK declares it. */
+#if FORCE_OLD_API || !defined(MAC_OS_X_VERSION_10_6)
+#define SDL_COCOA_USE_OLD_CGDISPLAY_API 1
+typedef CFDictionaryRef SDL_CocoaDisplayModeRef;
+#else
+#define SDL_COCOA_USE_OLD_CGDISPLAY_API 0
+typedef CGDisplayModeRef SDL_CocoaDisplayModeRef;
+#endif
+
+/* Small wrappers hiding the difference between the old (CFDictionary-based,
+ * 10.0+) and the new (CGDisplayMode-based, 10.6+) display mode APIs.
+ * Both return +1 retained references (or NULL). */
+static SDL_CocoaDisplayModeRef CopyCurrentDisplayMode(CGDirectDisplayID display)
+{
+#if SDL_COCOA_USE_OLD_CGDISPLAY_API
+    CFDictionaryRef moderef = CGDisplayCurrentMode(display);
+    if (moderef) {
+        CFRetain(moderef);
+    }
+    return moderef;
+#else
+    return CGDisplayCopyDisplayMode(display);
+#endif
+}
+
+static void ReleaseDisplayModeRef(SDL_CocoaDisplayModeRef moderef)
+{
+#if SDL_COCOA_USE_OLD_CGDISPLAY_API
+    if (moderef) {
+        CFRelease(moderef);
+    }
+#else
+    CGDisplayModeRelease(moderef);  /* NULL is ok */
+#endif
+}
+
+static CFArrayRef CopyAllDisplayModes(CGDirectDisplayID display, CFDictionaryRef options)
+{
+#if SDL_COCOA_USE_OLD_CGDISPLAY_API
+    CFArrayRef modes = CGDisplayAvailableModes(display);
+    (void) options;
+    if (modes) {
+        CFRetain(modes);
+    }
+    return modes;
+#else
+    return CGDisplayCopyAllDisplayModes(display, options);
+#endif
+}
+
 
 static int CG_SetError(const char *prefix, CGDisplayErr result)
 {
@@ -84,9 +143,20 @@ static int CG_SetError(const char *prefix, CGDisplayErr result)
     return SDL_SetError("%s: %s", prefix, error);
 }
 
-static int GetDisplayModeRefreshRate(CGDisplayModeRef vidmode, CVDisplayLinkRef link)
+static int GetDisplayModeRefreshRate(SDL_CocoaDisplayModeRef vidmode, CVDisplayLinkRef link)
 {
+#if SDL_COCOA_USE_OLD_CGDISPLAY_API
+    int refreshRate = 0;
+    CFNumberRef number = CFDictionaryGetValue(vidmode, kCGDisplayRefreshRate);
+    if (number) {
+        double rate = 0.0;
+        if (CFNumberGetValue(number, kCFNumberDoubleType, &rate)) {
+            refreshRate = (int) (rate + 0.5);
+        }
+    }
+#else
     int refreshRate = (int) (CGDisplayModeGetRefreshRate(vidmode) + 0.5);
+#endif
 
     /* CGDisplayModeGetRefreshRate can return 0 (eg for built-in displays). */
     if (refreshRate == 0 && link != NULL) {
@@ -99,8 +169,13 @@ static int GetDisplayModeRefreshRate(CGDisplayModeRef vidmode, CVDisplayLinkRef
     return refreshRate;
 }
 
-static SDL_bool HasValidDisplayModeFlags(CGDisplayModeRef vidmode)
+static SDL_bool HasValidDisplayModeFlags(SDL_CocoaDisplayModeRef vidmode)
 {
+#if SDL_COCOA_USE_OLD_CGDISPLAY_API
+    /* The old API modes were not flag-filtered (matching SDL up to 2.0.9);
+     * unusable modes are rejected by their pixel format instead. */
+    (void) vidmode;
+#else
     uint32_t ioflags = CGDisplayModeGetIOFlags(vidmode);
 
     /* Filter out modes which have flags that we don't want. */
@@ -112,12 +187,33 @@ static SDL_bool HasValidDisplayModeFlags(CGDisplayModeRef vidmode)
     if (!(ioflags & kDisplayModeValidFlag) || !(ioflags & kDisplayModeSafeFlag)) {
         return SDL_FALSE;
     }
+#endif
 
     return SDL_TRUE;
 }
 
-static Uint32 GetDisplayModePixelFormat(CGDisplayModeRef vidmode)
+static Uint32 GetDisplayModePixelFormat(SDL_CocoaDisplayModeRef vidmode)
 {
+#if SDL_COCOA_USE_OLD_CGDISPLAY_API
+    long bpp = 0;
+    CFNumberRef number = CFDictionaryGetValue(vidmode, kCGDisplayBitsPerPixel);
+    Uint32 pixelformat = SDL_PIXELFORMAT_UNKNOWN;
+
+    if (number) {
+        CFNumberGetValue(number, kCFNumberLongType, &bpp);
+    }
+    switch (bpp) {
+    case 32:
+        pixelformat = SDL_PIXELFORMAT_ARGB8888;
+        break;
+    case 16:
+        pixelformat = SDL_PIXELFORMAT_ARGB1555;
+        break;
+    default:
+        /* ignore 8-bit and such for now. */
+        break;
+    }
+#else
     /* This API is deprecated in 10.11 with no good replacement (as of 10.15). */
     CFStringRef fmt = CGDisplayModeCopyPixelEncoding(vidmode);
     Uint32 pixelformat = SDL_PIXELFORMAT_UNKNOWN;
@@ -128,21 +224,44 @@ static Uint32 GetDisplayModePixelFormat(CGDisplayModeRef vidmode)
     } else if (CFStringCompare(fmt, CFSTR(IO16BitDirectPixels),
                         kCFCompareCaseInsensitive) == kCFCompareEqualTo) {
         pixelformat = SDL_PIXELFORMAT_ARGB1555;
+#ifdef kIO30BitDirectPixels /* Added in the 10.11 SDK */
     } else if (CFStringCompare(fmt, CFSTR(kIO30BitDirectPixels),
                         kCFCompareCaseInsensitive) == kCFCompareEqualTo) {
         pixelformat = SDL_PIXELFORMAT_ARGB2101010;
+#endif
     } else {
         /* ignore 8-bit and such for now. */
     }
 
     CFRelease(fmt);
+#endif
 
     return pixelformat;
 }
 
-static SDL_bool GetDisplayMode(_THIS, CGDisplayModeRef vidmode, SDL_bool vidmodeCurrent, CFArrayRef modelist, CVDisplayLinkRef link, SDL_DisplayMode *mode)
+static SDL_bool GetDisplayMode(_THIS, SDL_CocoaDisplayModeRef vidmode, SDL_bool vidmodeCurrent, CFArrayRef modelist, CVDisplayLinkRef link, SDL_DisplayMode *mode)
 {
     SDL_DisplayModeData *data;
+#if SDL_COCOA_USE_OLD_CGDISPLAY_API
+    int width = 0;
+    int height = 0;
+    int refreshrate = GetDisplayModeRefreshRate(vidmode, link);
+    Uint32 format = GetDisplayModePixelFormat(vidmode);
+    CFMutableArrayRef modes;
+    {
+        long w = 0, h = 0;
+        CFNumberRef number = CFDictionaryGetValue(vidmode, kCGDisplayWidth);
+        if (number) {
+            CFNumberGetValue(number, kCFNumberLongType, &w);
+        }
+        number = CFDictionaryGetValue(vidmode, kCGDisplayHeight);
+        if (number) {
+            CFNumberGetValue(number, kCFNumberLongType, &h);
+        }
+        width = (int) w;
+        height = (int) h;
+    }
+#else
     bool usableForGUI = CGDisplayModeIsUsableForDesktopGUI(vidmode);
     int width = (int) CGDisplayModeGetWidth(vidmode);
     int height = (int) CGDisplayModeGetHeight(vidmode);
@@ -151,6 +270,7 @@ static SDL_bool GetDisplayMode(_THIS, CGDisplayModeRef vidmode, SDL_bool vidmode
     Uint32 format = GetDisplayModePixelFormat(vidmode);
     bool interlaced = (ioflags & kDisplayModeInterlacedFlag) != 0;
     CFMutableArrayRef modes;
+#endif
 
     if (format == SDL_PIXELFORMAT_UNKNOWN) {
         return SDL_FALSE;
@@ -171,7 +291,7 @@ static SDL_bool GetDisplayMode(_THIS, CGDisplayModeRef vidmode, SDL_bool vidmode
      * prefered, and it can add CGDisplayModes to the DisplayModeData's list of
      * modes to try (see comment below for why that's necessary).
      * CGDisplayModeGetPixelWidth and friends are only available in 10.8+. */
-#ifdef MAC_OS_X_VERSION_10_8
+#if !SDL_COCOA_USE_OLD_CGDISPLAY_API && defined(MAC_OS_X_VERSION_10_8)
     if (modelist != NULL && floor(NSAppKitVersionNumber) > NSAppKitVersionNumber10_7) {
         int pixelW = (int) CGDisplayModeGetPixelWidth(vidmode);
         int pixelH = (int) CGDisplayModeGetPixelHeight(vidmode);
@@ -294,7 +414,7 @@ static const char *Cocoa_GetDisplayName(CGDirectDisplayID displayID)
 }
 
 void Cocoa_InitModes(_THIS)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     CGDisplayErr result;
     CGDirectDisplayID *displays;
@@ -321,7 +441,7 @@ void Cocoa_InitModes(_THIS)
             SDL_VideoDisplay display;
             SDL_DisplayData *displaydata;
             SDL_DisplayMode mode;
-            CGDisplayModeRef moderef = NULL;
+            SDL_CocoaDisplayModeRef moderef = NULL;
             CVDisplayLinkRef link = NULL;
 
             if (pass == 0) {
@@ -338,7 +458,7 @@ void Cocoa_InitModes(_THIS)
                 continue;
             }
 
-            moderef = CGDisplayCopyDisplayMode(displays[i]);
+            moderef = CopyCurrentDisplayMode(displays[i]);
 
             if (!moderef) {
                 continue;
@@ -346,7 +466,7 @@ void Cocoa_InitModes(_THIS)
 
             displaydata = (SDL_DisplayData *) SDL_malloc(sizeof(*displaydata));
             if (!displaydata) {
-                CGDisplayModeRelease(moderef);
+                ReleaseDisplayModeRef(moderef);
                 continue;
             }
             displaydata->display = displays[i];
@@ -358,14 +478,14 @@ void Cocoa_InitModes(_THIS)
             display.name = (char *)Cocoa_GetDisplayName(displays[i]);
             if (!GetDisplayMode(_this, moderef, SDL_TRUE, NULL, link, &mode)) {
                 CVDisplayLinkRelease(link);
-                CGDisplayModeRelease(moderef);
+                ReleaseDisplayModeRef(moderef);
                 SDL_free(display.name);
                 SDL_free(displaydata);
                 continue;
             }
 
             CVDisplayLinkRelease(link);
-            CGDisplayModeRelease(moderef);
+            ReleaseDisplayModeRef(moderef);
 
             display.desktop_mode = mode;
             display.current_mode = mode;
@@ -423,7 +543,7 @@ int Cocoa_GetDisplayUsableBounds(_THIS, SDL_VideoDisplay * display, SDL_Rect * r
 }
 
 int Cocoa_GetDisplayDPI(_THIS, SDL_VideoDisplay * display, float * ddpi, float * hdpi, float * vdpi)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     const float MM_IN_INCH = 25.4f;
 
@@ -439,7 +559,7 @@ int Cocoa_GetDisplayDPI(_THIS, SDL_VideoDisplay * display, float * ddpi, float *
     for (NSScreen *screen in screens) {
         const CGDirectDisplayID dpyid = (const CGDirectDisplayID ) [[[screen deviceDescription] objectForKey:@"NSScreenNumber"] unsignedIntValue];
         if (dpyid == data->display) {
-#ifdef MAC_OS_X_VERSION_10_8
+#if !SDL_COCOA_USE_OLD_CGDISPLAY_API && defined(MAC_OS_X_VERSION_10_8)
             /* Neither CGDisplayScreenSize(description's NSScreenNumber) nor [NSScreen backingScaleFactor] can calculate the correct dpi in macOS. E.g. backingScaleFactor is always 2 in all display modes for rMBP 16" */
             if (floor(NSAppKitVersionNumber) > NSAppKitVersionNumber10_7) {
                 CFStringRef dmKeys[1] = { kCGDisplayShowDuplicateLowResolutionModes };
@@ -473,10 +593,14 @@ int Cocoa_GetDisplayDPI(_THIS, SDL_VideoDisplay * display, float * ddpi, float *
             } else
 #endif
             {
+#ifdef MAC_OS_X_VERSION_10_7
                 // fallback for 10.7
                 scaleFactor = [screen backingScaleFactor];
                 displayNativeSize.width = displayNativeSize.width * scaleFactor;
                 displayNativeSize.height = displayNativeSize.height * scaleFactor;
+#else
+                (void) scaleFactor; /* no Retina displays before 10.7 */
+#endif
                 break;
             }
         }
@@ -504,14 +628,14 @@ void Cocoa_GetDisplayModes(_THIS, SDL_VideoDisplay * display)
 {
     SDL_DisplayData *data = (SDL_DisplayData *) display->driverdata;
     CVDisplayLinkRef link = NULL;
-    CGDisplayModeRef desktopmoderef;
+    SDL_CocoaDisplayModeRef desktopmoderef;
     SDL_DisplayMode desktopmode;
     CFArrayRef modes;
     CFDictionaryRef dict = NULL;
 
     CVDisplayLinkCreateWithCGDisplay(data->display, &link);
 
-    desktopmoderef = CGDisplayCopyDisplayMode(data->display);
+    desktopmoderef = CopyCurrentDisplayMode(data->display);
 
     /* CopyAllDisplayModes won't always contain the desktop display mode (if
      * NULL is passed in) - for example on a retina 15" MBP, System Preferences
@@ -526,7 +650,7 @@ void Cocoa_GetDisplayModes(_THIS, SDL_VideoDisplay * display)
         }
     }
 
-    CGDisplayModeRelease(desktopmoderef);
+    ReleaseDisplayModeRef(desktopmoderef);
 
     /* By default, CGDisplayCopyAllDisplayModes will only get a subset of the
      * system's available modes. For example on a 15" 2016 MBP, users can
@@ -539,7 +663,7 @@ void Cocoa_GetDisplayModes(_THIS, SDL_VideoDisplay * display)
      * the content of the screen to move up, which this setting avoids:
      * https://bugzilla.libsdl.org/show_bug.cgi?id=4822
      */
-#ifdef MAC_OS_X_VERSION_10_8
+#if !SDL_COCOA_USE_OLD_CGDISPLAY_API && defined(MAC_OS_X_VERSION_10_8)
     if (floor(NSAppKitVersionNumber) > NSAppKitVersionNumber10_7) {
         const CFStringRef dictkeys[] = {kCGDisplayShowDuplicateLowResolutionModes};
         const CFBooleanRef dictvalues[] = {kCFBooleanTrue};
@@ -552,7 +676,7 @@ void Cocoa_GetDisplayModes(_THIS, SDL_VideoDisplay * display)
     }
 #endif
 
-    modes = CGDisplayCopyAllDisplayModes(data->display, dict);
+    modes = CopyAllDisplayModes(data->display, dict);
 
     if (dict) {
         CFRelease(dict);
@@ -563,7 +687,7 @@ void Cocoa_GetDisplayModes(_THIS, SDL_VideoDisplay * display)
         const CFIndex count = CFArrayGetCount(modes);
 
         for (i = 0; i < count; i++) {
-            CGDisplayModeRef moderef = (CGDisplayModeRef) CFArrayGetValueAtIndex(modes, i);
+            SDL_CocoaDisplayModeRef moderef = (SDL_CocoaDisplayModeRef) CFArrayGetValueAtIndex(modes, i);
             SDL_DisplayMode mode;
 
             if (GetDisplayMode(_this, moderef, SDL_FALSE, modes, link, &mode)) {
@@ -587,8 +711,12 @@ static CGError SetDisplayModeForDisplay(CGDirectDisplayID display, SDL_DisplayMo
      */
     CGError result = kCGErrorFailure;
     for (CFIndex i = 0; i < CFArrayGetCount(data->modes); i++) {
-        CGDisplayModeRef moderef = (CGDisplayModeRef)CFArrayGetValueAtIndex(data->modes, i);
+        SDL_CocoaDisplayModeRef moderef = (SDL_CocoaDisplayModeRef)CFArrayGetValueAtIndex(data->modes, i);
+#if SDL_COCOA_USE_OLD_CGDISPLAY_API
+        result = CGDisplaySwitchToMode(display, moderef);
+#else
         result = CGDisplaySetDisplayMode(display, moderef, NULL);
+#endif
         if (result == kCGErrorSuccess) {
             /* If this mode works, try it first next time. */
             CFArrayExchangeValuesAtIndices(data->modes, i, 0);
diff --git src/video/cocoa/SDL_cocoamouse.m src/video/cocoa/SDL_cocoamouse.m
index e70c40956..aff231621 100644
--- src/video/cocoa/SDL_cocoamouse.m
+++ src/video/cocoa/SDL_cocoamouse.m
@@ -53,7 +53,7 @@
         NSData *cursorData = [NSData dataWithBytesNoCopy:&cursorBytes[0]
                                                   length:sizeof(cursorBytes)
                                             freeWhenDone:NO];
-        NSImage *cursorImage = [[NSImage alloc] initWithData:cursorData];
+        NSImage *cursorImage = SDL_COCOA_AUTORELEASE([[NSImage alloc] initWithData:cursorData]);
         invisibleCursor = [[NSCursor alloc] initWithImage:cursorImage
                                                   hotSpot:NSZeroPoint];
     }
@@ -64,7 +64,7 @@
 
 
 static SDL_Cursor *Cocoa_CreateDefaultCursor()
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSCursor *nscursor;
     SDL_Cursor *cursor = NULL;
@@ -74,7 +74,7 @@ static SDL_Cursor *Cocoa_CreateDefaultCursor()
     if (nscursor) {
         cursor = SDL_calloc(1, sizeof(*cursor));
         if (cursor) {
-            cursor->driverdata = (void *)CFBridgingRetain(nscursor);
+            cursor->driverdata = SDL_CFBridgingRetain(nscursor);
         }
     }
 
@@ -82,7 +82,7 @@ static SDL_Cursor *Cocoa_CreateDefaultCursor()
 }}
 
 static SDL_Cursor *Cocoa_CreateCursor(SDL_Surface * surface, int hot_x, int hot_y)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSImage *nsimage;
     NSCursor *nscursor = NULL;
@@ -90,13 +90,13 @@ static SDL_Cursor *Cocoa_CreateCursor(SDL_Surface * surface, int hot_x, int hot_
 
     nsimage = Cocoa_CreateImage(surface);
     if (nsimage) {
-        nscursor = [[NSCursor alloc] initWithImage: nsimage hotSpot: NSMakePoint(hot_x, hot_y)];
+        nscursor = SDL_COCOA_AUTORELEASE([[NSCursor alloc] initWithImage: nsimage hotSpot: NSMakePoint(hot_x, hot_y)]);
     }
 
     if (nscursor) {
         cursor = SDL_calloc(1, sizeof(*cursor));
         if (cursor) {
-            cursor->driverdata = (void *)CFBridgingRetain(nscursor);
+            cursor->driverdata = SDL_CFBridgingRetain(nscursor);
         }
     }
 
@@ -113,7 +113,7 @@ static NSCursor *LoadHiddenSystemCursor(NSString *cursorName, SEL fallback)
     /* we can't do animation atm.  :/ */
     const int frames = (int)[[info valueForKey:@"frames"] integerValue];
     NSCursor *cursor;
-    NSImage *image = [[NSImage alloc] initWithContentsOfFile:[cursorPath stringByAppendingPathComponent:@"cursor.pdf"]];
+    NSImage *image = SDL_COCOA_AUTORELEASE([[NSImage alloc] initWithContentsOfFile:[cursorPath stringByAppendingPathComponent:@"cursor.pdf"]]);
     if ((image == nil) || (image.isValid == NO)) {
         return [NSCursor performSelector:fallback];
     }
@@ -125,7 +125,7 @@ static NSCursor *LoadHiddenSystemCursor(NSString *cursorName, SEL fallback)
         const NSCompositingOperation operation = NSCompositeCopy;
         #endif
         const NSSize cropped_size = NSMakeSize(image.size.width, (int) (image.size.height / frames));
-        NSImage *cropped = [[NSImage alloc] initWithSize:cropped_size];
+        NSImage *cropped = SDL_COCOA_AUTORELEASE([[NSImage alloc] initWithSize:cropped_size]);
         if (cropped == nil) {
             return [NSCursor performSelector:fallback];
         }
@@ -139,12 +139,12 @@ static NSCursor *LoadHiddenSystemCursor(NSString *cursorName, SEL fallback)
         image = cropped;
     }
 
-    cursor = [[NSCursor alloc] initWithImage:image hotSpot:NSMakePoint([[info valueForKey:@"hotx"] doubleValue], [[info valueForKey:@"hoty"] doubleValue])];
+    cursor = SDL_COCOA_AUTORELEASE([[NSCursor alloc] initWithImage:image hotSpot:NSMakePoint([[info valueForKey:@"hotx"] doubleValue], [[info valueForKey:@"hoty"] doubleValue])]);
     return cursor;
 }
 
 static SDL_Cursor *Cocoa_CreateSystemCursor(SDL_SystemCursor id)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSCursor *nscursor = NULL;
     SDL_Cursor *cursor = NULL;
@@ -195,7 +195,7 @@ static SDL_Cursor *Cocoa_CreateSystemCursor(SDL_SystemCursor id)
         cursor = SDL_calloc(1, sizeof(*cursor));
         if (cursor) {
             /* We'll free it later, so retain it here */
-            cursor->driverdata = (void *)CFBridgingRetain(nscursor);
+            cursor->driverdata = SDL_CFBridgingRetain(nscursor);
         }
     }
 
@@ -203,14 +203,14 @@ static SDL_Cursor *Cocoa_CreateSystemCursor(SDL_SystemCursor id)
 }}
 
 static void Cocoa_FreeCursor(SDL_Cursor * cursor)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
-    CFBridgingRelease(cursor->driverdata);
+    (void) SDL_CFBridgingRelease(cursor->driverdata);
     SDL_free(cursor);
 }}
 
 static int Cocoa_ShowCursor(SDL_Cursor * cursor)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoDevice *device = SDL_GetVideoDevice();
     SDL_Window *window = (device ? device->windows : NULL);
@@ -343,9 +343,28 @@ static int Cocoa_CaptureMouse(SDL_Window *window)
     return 0;
 }
 
+#ifndef MAC_OS_X_VERSION_10_6
+/* +[NSEvent pressedMouseButtons] arrived with the 10.6 SDK */
+static NSUInteger Cocoa_PressedMouseButtons(void)
+{
+    NSUInteger buttons = 0;
+    int btn;
+    for (btn = 0; btn < 5; ++btn) {
+        if (CGEventSourceButtonState(kCGEventSourceStateCombinedSessionState, (CGMouseButton) btn)) {
+            buttons |= (1 << btn);
+        }
+    }
+    return buttons;
+}
+#endif
+
 static Uint32 Cocoa_GetGlobalMouseState(int *x, int *y)
 {
+#ifdef MAC_OS_X_VERSION_10_6
     const NSUInteger cocoaButtons = [NSEvent pressedMouseButtons];
+#else
+    const NSUInteger cocoaButtons = Cocoa_PressedMouseButtons();
+#endif
     const NSPoint cocoaLocation = [NSEvent mouseLocation];
     Uint32 retval = 0;
 
@@ -521,13 +540,16 @@ void Cocoa_HandleMouseWheel(SDL_Window *window, NSEvent *event)
     y = [event deltaY];
     direction = SDL_MOUSEWHEEL_NORMAL;
 
+#ifdef MAC_OS_X_VERSION_10_7 /* these NSEvent methods arrived with the 10.7 SDK */
     if ([event isDirectionInvertedFromDevice] == YES) {
         direction = SDL_MOUSEWHEEL_FLIPPED;
     }
 
     /* For discrete scroll events from conventional mice, always send a full tick.
        For continuous scroll events from trackpads, send fractional deltas for smoother scrolling. */
-    if (![event hasPreciseScrollingDeltas]) {
+    if (![event hasPreciseScrollingDeltas])
+#endif
+    {
         if (x > 0) {
             x = SDL_ceil(x);
         } else if (x < 0) {
diff --git src/video/cocoa/SDL_cocoaopengl.h src/video/cocoa/SDL_cocoaopengl.h
index f152a726c..bddf20b01 100644
--- src/video/cocoa/SDL_cocoaopengl.h
+++ src/video/cocoa/SDL_cocoaopengl.h
@@ -44,6 +44,9 @@ struct SDL_GLDriverData
     SDL_atomic_t dirty;
     SDL_Window *window;
     CVDisplayLinkRef displayLink;
+    /* Explicit ivar: synthesized ivars are unavailable with the fragile
+       Objective-C ABI (32-bit Mac OS X) and with GCC. */
+    NSOpenGLPixelFormat *_openglPixelFormat;
     @public SDL_mutex *swapIntervalMutex;
     @public SDL_cond *swapIntervalCond;
     @public SDL_atomic_t swapIntervalSetting;
